<?php
ob_start('ob_gzhandler');
include("include/config.php");

function getCityName($latitude, $longitude, $apiKey) {
    $url = "https://maps.googleapis.com/maps/api/geocode/json?latlng={$latitude},{$longitude}&key={$apiKey}";

    // Make a request to the Google Maps Geocoding API
    $response = file_get_contents($url);

    // Decode the JSON response
    $data = json_decode($response, true);

    // Check if the response was successful
    if ($data['status'] == 'OK') {
        // Loop through the results to find the city name
        foreach ($data['results'] as $result) {
            foreach ($result['address_components'] as $component) {
                if (in_array('locality', $component['types'])) {
                    // Return the city name
                    return $component['long_name'];
                }
            }
        }
    }

    // Return null if the city name couldn't be found
    return null;
}
$apiKey = 'AIzaSyCbq3_1wQQjZVAI25qnPgzxhOtp6NLe55k'; // Replace with your actual API key

$result = [];
$res = $mysqli->query("SELECT project_stages.`Location`, projects.ReferenceNo, stages.StageName FROM `project_stages`,projects, stages WHERE `project_stages`.`ProjectID` = projects.ProjectID and project_stages.StageID = stages.StageID AND `Synced` = '1' ORDER BY `StageDate` DESC LIMIT 1000");

$numrows = mysqli_num_rows($res);
if ($numrows > 0) {
    while ($row = $res->fetch_assoc()) {
       
            list($latitude, $longitude) = explode('|',  $row['Location']);
            $cityName = getCityName($latitude, $longitude, $apiKey);
        
            $result[] = [
                'lat' => $latitude,
                'lng' => $longitude,
                'area' => $cityName,
                'status' => 'unmarked',
                'ref' => $row['ReferenceNo'],
                'vtype' => $row['StageName'],
                'showDate' => null,
            ];
        
    }    
} else {
    $return["error"] = true;
    $return["message"] = "Not Found!";
}
header('Content-Type: application/json');
echo json_encode($result);
