<?php
// Set timezone
date_default_timezone_set("Asia/Riyadh");

// Database connection
$dsn = 'mysql:host=localhost;dbname=rdappnet_testrdapp';
$username = 'rdappnet_testrdapp';
$password = 'X]8wlXu)KxcG';
$options = [];

try {
    $pdo = new PDO($dsn, $username, $password, $options);
    $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
} catch (PDOException $e) {
    die('Database connection failed: ' . $e->getMessage());
}

// Function to handle file upload
function handleFileUpload($file, $key, $StageID)
{
    // Determine upload directory based on StageID
    if ($StageID == 11) {
        $uploadDir = '../../uploads/reports/rd6/';
    } elseif ($StageID == 12) {
        $uploadDir = '../../uploads/reports/rd7/';
    } elseif ($StageID == 16) {
        $uploadDir = '../../uploads/reports/rd3/';
    } else {
        // Default or error handling if needed
        error_log("Invalid StageID: $StageID");
        return null;
    }

    if (!is_dir($uploadDir)) {
        die('Upload directory does not exist: ' . $uploadDir);
    }

    $filename = $file['name'][$key]['File'];
    $extension = pathinfo($filename, PATHINFO_EXTENSION);
    $newfilename = $key . '_' . date('Y-m-d_H-i-s') . "." . $extension;
    $targetFile = $uploadDir . $newfilename;

    error_log("Attempting to upload file: $filename to $targetFile");

    if (move_uploaded_file($file['tmp_name'][$key]['File'], $targetFile)) {
        error_log("File upload succeeded for QID: $key, new filename: $newfilename");
        return $newfilename;
    } else {
        error_log("File upload failed for QID: $key: " . print_r($file, true));
        return null;
    }
}

// Extract data from POST request
$data = $_POST['Data'];
$PStageID = $_POST['PStageID'];
$createdAt = date('Y-m-d H:i:s');
$PerToken = $_POST['PerToken'];
$PerUserID = $_POST['PerUserID'];
$PerRoleID = $_POST['PerRoleID'];
$TodayIs = date("Y-m-d H:i:s");

$UserCheck = $pdo->prepare("SELECT Token FROM `login_tokens` WHERE `UID` = ? AND `Token` = ? LIMIT 1");
$UserCheck->bindParam(1, $PerUserID);
$UserCheck->bindParam(2, $PerToken);
$UserCheck->execute();
$UserCheckResult = $UserCheck->fetch();
if (!$UserCheckResult) {
    $return["error"] = true;
    $return["message"] = "Access denied!";
} else {
    $pdo->beginTransaction();

    try {

        $stmt = $pdo->prepare("SELECT `ProjectID`, `StageID`, Deleted, Synced FROM `project_stages` WHERE `PStageID` = ? ORDER BY `PStageID` DESC LIMIT 1");
        $stmt->execute([$PStageID]);
        $row11 = $stmt->fetch();

        if ($row11) {
            $ProjectID = $row11['ProjectID'];
            $StageID = $row11['StageID'];
            $Deleted = $row11['Deleted'];
            $Synced = $row11['Synced'];

if ($Deleted == 1 and $Synced == 0){
            if ($StageID == 11) {

                $pdo->prepare("UPDATE `project_stages` SET `Deleted` = '0', `Synced` = '1' WHERE `PStageID` = ? AND `StageID` = 11")
                    ->execute([$PStageID]);

                $stmt = $pdo->prepare("SELECT `DID` FROM `Declaration` WHERE `ProjectID` = ? AND `InspectorID` = ?");
                $stmt->execute([$ProjectID, $PerUserID]);
                $res = $stmt->fetch();

                if (!$res) {
                    $pdo->prepare("INSERT INTO `Declaration` (`ProjectID`, `InspectorID`, `CreatedAt`) VALUES (?, ?, ?)")
                        ->execute([$ProjectID, $PerUserID, $TodayIs]);
                }

                $pdo->prepare("UPDATE `rd6_reports` SET `PStageID` = ? WHERE `ProjectID` = ?")
                    ->execute([$PStageID, $ProjectID]);

                $stmt = $pdo->prepare("SELECT `RD6ID` FROM `rd6_reports` WHERE `ProjectID` = ? AND `Deleted` = '0'");
                $stmt->execute([$ProjectID]);
                $rowRD6ID = $stmt->fetch();

                $stmt = $pdo->prepare("SELECT `InsUserID` FROM `rd6_reports` WHERE `ProjectID` = ? AND `Deleted` = '0'");
                $stmt->execute([$ProjectID]);
                $rowIns = $stmt->fetch();

                $stmt = $pdo->prepare("SELECT `DesUserID` FROM `rd6_reports` WHERE `ProjectID` = ? AND `Deleted` = '0'");
                $stmt->execute([$ProjectID]);
                $rowDes = $stmt->fetch();

                if ($rowIns['InsUserID'] == $PerUserID) {
                    $action = 1;
                } elseif ($rowDes['DesUserID'] == $PerUserID) {
                    $action = 5;
                } else {
                    $action = 12;
                }

                $pdo->prepare("INSERT INTO `rd6_history` (`RD6ID`, `UpdaterID`, `Action`, `CreatedAt`) VALUES (?, ?, ?, ?)")
                    ->execute([$rowRD6ID['RD6ID'], $PerUserID, $action, $TodayIs]);

                // Process file uploads first and insert them into the database
                foreach ($data as $key => $item) {
                    $qid = $item['QID'];
                    $type = $item['Type'];

                    if ($type === 'File' && isset($_FILES["Data"]['tmp_name'][$key]['File'])) {
                        error_log("Processing file upload for QID: $qid");
                        $filePath = handleFileUpload($_FILES["Data"], $key, $StageID);
                        if ($filePath) {
                            $stmt = $pdo->prepare('INSERT INTO rd6_answers (PStageID, QID, Answer, OptionID, MissingData, CreatedAt, Deleted, RSelect, CSelect, Term, AnswerAR, TermAR)
                                       VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)');
                            $stmt->execute([$PStageID, $qid, $filePath, null, '0', $createdAt, '0', null, null, null, null, null]);
                            error_log("File uploaded and data inserted for QID: $qid");
                        } else {
                            throw new Exception('File upload failed for QID: ' . $qid);
                        }
                    }
                }

                // Insert remaining data, skipping those with Type == File
                foreach ($data as $item) {
                    $qid = $item['QID'];
                    $type = $item['Type'];
                    if ($type === 'File') continue;

                    $answer = isset($item['Answer']) ? $item['Answer'] : null;
                    $optionID = isset($item['OptionID']) ? $item['OptionID'] : null;
                    $missingData = isset($item['MissingData']) ? $item['MissingData'] : 0;
                    $rSelect = isset($item['RSelect']) ? $item['RSelect'] : null;
                    $cSelect = isset($item['CSelect']) ? $item['CSelect'] : null;
                    $term = isset($item['Term']) ? $item['Term'] : null;
                    $answerAR = isset($item['AnswerAR']) ? $item['AnswerAR'] : null;
                    $termAR = isset($item['TermAR']) ? $item['TermAR'] : null;
                    $deleted = 0;

                    // Insert data if OptionID or Answer contain commas
                    if (strpos($optionID, ',') !== false || strpos($answer, ',') !== false) {
                        $optionIDs = $optionID ? explode(',', $optionID) : [null];
                        $answers = $answer ? explode(',', $answer) : [null];

                        foreach ($optionIDs as $optID) {
                            foreach ($answers as $ans) {
                                $stmt = $pdo->prepare('INSERT INTO rd6_answers (PStageID, QID, Answer, OptionID, MissingData, CreatedAt, Deleted, RSelect, CSelect, Term, AnswerAR, TermAR)
                                           VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)');
                                $stmt->execute([$PStageID, $qid, $ans, $optID, $missingData, $createdAt, $deleted, $rSelect, $cSelect, $term, $answerAR, $termAR]);
                            }
                        }
                    } else {
                        $stmt = $pdo->prepare('INSERT INTO rd6_answers (PStageID, QID, Answer, OptionID, MissingData, CreatedAt, Deleted, RSelect, CSelect, Term, AnswerAR, TermAR)
                                   VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)');
                        $stmt->execute([$PStageID, $qid, $answer, $optionID, $missingData, $createdAt, $deleted, $rSelect, $cSelect, $term, $answerAR, $termAR]);
                    }
                }

                $pdo->commit();
                $return["error"] = false;
            } else if ($StageID == 12) {

                $pdo->prepare("UPDATE `project_stages` SET `Deleted` = '0', `Synced` = '1' WHERE `PStageID` = ? AND `StageID` = 12")
                    ->execute([$PStageID]);

                $stmt = $pdo->prepare("SELECT `DID` FROM `Declaration` WHERE `ProjectID` = ? AND `InspectorID` = ?");
                $stmt->execute([$ProjectID, $PerUserID]);
                $res = $stmt->fetch();

                if (!$res) {
                    $pdo->prepare("INSERT INTO `Declaration` (`ProjectID`, `InspectorID`, `CreatedAt`) VALUES (?, ?, ?)")
                        ->execute([$ProjectID, $PerUserID, $TodayIs]);
                }

                $pdo->prepare("UPDATE `rd7_reports` SET `PStageID` = ? WHERE `ProjectID` = ?")
                    ->execute([$PStageID, $ProjectID]);

                $stmt = $pdo->prepare("SELECT `RD7ID` FROM `rd7_reports` WHERE `ProjectID` = ? AND `Deleted` = '0'");
                $stmt->execute([$ProjectID]);
                $rowRD7ID = $stmt->fetch();

                $pdo->prepare("INSERT INTO `rd7_history` (`RD7ID`, `UpdaterID`, `Action`, `CreatedAt`) VALUES (?, ?, ?, ?)")
                    ->execute([$rowRD7ID['RD7ID'], $PerUserID, 'RD7 Created', $TodayIs]);

                // Process file uploads first and insert them into the database
                foreach ($data as $key => $item) {
                    $qid = $item['QID'];
                    $type = $item['Type'];

                    if ($type === 'File' && isset($_FILES["Data"]['tmp_name'][$key]['File'])) {
                        error_log("Processing file upload for QID: $qid");
                        $filePath = handleFileUpload($_FILES["Data"], $key, $StageID);
                        if ($filePath) {
                            $stmt = $pdo->prepare('INSERT INTO rd7_answers (PStageID, QID, Answer, OptionID, MissingData, CreatedAt, Deleted, RSelect, CSelect, Term, AnswerAR, TermAR)
                               VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)');
                            $stmt->execute([$PStageID, $qid, $filePath, null, '0', $createdAt, '0', null, null, null, null, null]);
                            error_log("File uploaded and data inserted for QID: $qid");
                        } else {
                            throw new Exception('File upload failed for QID: ' . $qid);
                        }
                    }
                }

                // Insert remaining data, skipping those with Type == File
                foreach ($data as $item) {
                    $qid = $item['QID'];
                    $type = $item['Type'];
                    if ($type === 'File') continue;

                    $answer = isset($item['Answer']) ? $item['Answer'] : null;
                    $optionID = isset($item['OptionID']) ? $item['OptionID'] : null;
                    $missingData = isset($item['MissingData']) ? $item['MissingData'] : 0;
                    $rSelect = isset($item['RSelect']) ? $item['RSelect'] : null;
                    $cSelect = isset($item['CSelect']) ? $item['CSelect'] : null;
                    $term = isset($item['Term']) ? $item['Term'] : null;
                    $answerAR = isset($item['AnswerAR']) ? $item['AnswerAR'] : null;
                    $termAR = isset($item['TermAR']) ? $item['TermAR'] : null;
                    $deleted = 0;

                    // Insert data if OptionID or Answer contain commas
                    if (strpos($optionID, ',') !== false || strpos($answer, ',') !== false) {
                        $optionIDs = $optionID ? explode(',', $optionID) : [null];
                        $answers = $answer ? explode(',', $answer) : [null];

                        foreach ($optionIDs as $optID) {
                            foreach ($answers as $ans) {
                                $stmt = $pdo->prepare('INSERT INTO rd7_answers (PStageID, QID, Answer, OptionID, MissingData, CreatedAt, Deleted, RSelect, CSelect, Term, AnswerAR, TermAR)
                                   VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)');
                                $stmt->execute([$PStageID, $qid, $ans, $optID, $missingData, $createdAt, $deleted, $rSelect, $cSelect, $term, $answerAR, $termAR]);
                            }
                        }
                    } else {
                        $stmt = $pdo->prepare('INSERT INTO rd7_answers (PStageID, QID, Answer, OptionID, MissingData, CreatedAt, Deleted, RSelect, CSelect, Term, AnswerAR, TermAR)
                           VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)');
                        $stmt->execute([$PStageID, $qid, $answer, $optionID, $missingData, $createdAt, $deleted, $rSelect, $cSelect, $term, $answerAR, $termAR]);
                    }
                }

                $pdo->commit();
                $return["error"] = false;
            } else if ($StageID == 16) {

                $pdo->prepare("UPDATE `project_stages` SET `Deleted` = '0', `Synced` = '1' WHERE `PStageID` = ? AND `StageID` = 16")
                    ->execute([$PStageID]);

                $stmt = $pdo->prepare("SELECT `DID` FROM `Declaration` WHERE `ProjectID` = ? AND `InspectorID` = ?");
                $stmt->execute([$ProjectID, $PerUserID]);
                $res = $stmt->fetch();

                if (!$res) {
                    $pdo->prepare("INSERT INTO `Declaration` (`ProjectID`, `InspectorID`, `CreatedAt`) VALUES (?, ?, ?)")
                        ->execute([$ProjectID, $PerUserID, $TodayIs]);
                }

                $pdo->prepare("UPDATE `rd3_reports` SET `PStageID` = ? WHERE `ProjectID` = ?")
                    ->execute([$PStageID, $ProjectID]);

                $stmt = $pdo->prepare("SELECT `RD3ID` FROM `rd3_reports` WHERE `ProjectID` = ? AND `Deleted` = '0'");
                $stmt->execute([$ProjectID]);
                $rowRD3ID = $stmt->fetch();

                $stmt = $pdo->prepare("SELECT `InsUserID` FROM `rd3_reports` WHERE `ProjectID` = ? AND `Deleted` = '0'");
                $stmt->execute([$ProjectID]);
                $rowIns = $stmt->fetch();

                if ($rowIns['InsUserID'] == $PerUserID) {
                    $pdo->prepare("update `rd3_reports` set `Status` = 'InProgress',`ins_status` = 'InProgress',`des_status` = 'InProgress',`insrev_status` = 'InProgress' where `RD3ID` = ?")
                        ->execute([$rowRD3ID['RD3ID']]);

                    $pdo->prepare("INSERT INTO `rd3_history` (`RD3ID`, `UpdaterID`, `Action`, `CreatedAt`) VALUES (?, ?, ?, ?)")
                        ->execute([$rowRD3ID['RD3ID'], $PerUserID, '1', $TodayIs]);
                } else {
                    $pdo->prepare("INSERT INTO `rd3_history` (`RD3ID`, `UpdaterID`, `Action`, `CreatedAt`) VALUES (?, ?, ?, ?)")
                        ->execute([$rowRD3ID['RD3ID'], $PerUserID, '11', $TodayIs]);
                }

                // Process file uploads first and insert them into the database
                foreach ($data as $key => $item) {
                    $qid = $item['QID'];
                    $type = $item['Type'];

                    if ($type === 'File' && isset($_FILES["Data"]['tmp_name'][$key]['File'])) {
                        error_log("Processing file upload for QID: $qid");
                        $filePath = handleFileUpload($_FILES["Data"], $key, $StageID);
                        if ($filePath) {
                            $stmt = $pdo->prepare('INSERT INTO rd3_answers (PStageID, QID, Answer, OptionID, MissingData, CreatedAt, Deleted, RSelect, CSelect, Term, AnswerAR, TermAR)
                           VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)');
                            $stmt->execute([$PStageID, $qid, $filePath, null, '0', $createdAt, '0', null, null, null, null, null]);
                            error_log("File uploaded and data inserted for QID: $qid");
                        } else {
                            throw new Exception('File upload failed for QID: ' . $qid);
                        }
                    }
                }

                // Insert remaining data, skipping those with Type == File
                foreach ($data as $item) {
                    $qid = $item['QID'];
                    $type = $item['Type'];
                    if ($type === 'File') continue;

                    $answer = isset($item['Answer']) ? $item['Answer'] : null;
                    $optionID = isset($item['OptionID']) ? $item['OptionID'] : null;
                    $missingData = isset($item['MissingData']) ? $item['MissingData'] : 0;
                    $rSelect = isset($item['RSelect']) ? $item['RSelect'] : null;
                    $cSelect = isset($item['CSelect']) ? $item['CSelect'] : null;
                    $term = isset($item['Term']) ? $item['Term'] : null;
                    $answerAR = isset($item['AnswerAR']) ? $item['AnswerAR'] : null;
                    $termAR = isset($item['TermAR']) ? $item['TermAR'] : null;
                    $deleted = 0;

                    // Insert data if OptionID or Answer contain commas
                    if (strpos($optionID, ',') !== false || strpos($answer, ',') !== false) {
                        $optionIDs = $optionID ? explode(',', $optionID) : [null];
                        $answers = $answer ? explode(',', $answer) : [null];

                        foreach ($optionIDs as $optID) {
                            foreach ($answers as $ans) {
                                $stmt = $pdo->prepare('INSERT INTO rd3_answers (PStageID, QID, Answer, OptionID, MissingData, CreatedAt, Deleted, RSelect, CSelect, Term, AnswerAR, TermAR)
                               VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)');
                                $stmt->execute([$PStageID, $qid, $ans, $optID, $missingData, $createdAt, $deleted, $rSelect, $cSelect, $term, $answerAR, $termAR]);
                            }
                        }
                    } else {
                        $stmt = $pdo->prepare('INSERT INTO rd3_answers (PStageID, QID, Answer, OptionID, MissingData, CreatedAt, Deleted, RSelect, CSelect, Term, AnswerAR, TermAR)
                       VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)');
                        $stmt->execute([$PStageID, $qid, $answer, $optionID, $missingData, $createdAt, $deleted, $rSelect, $cSelect, $term, $answerAR, $termAR]);
                    }
                }

                $pdo->commit();
                $return["error"] = false;
            } else {
                $return["error"] = true;
            }
        }else{
           $return["error"] = false; 
        }
        }
    } catch (Exception $e) {
        $pdo->rollBack();
        error_log('Transaction failed: ' . $e->getMessage());
        $return["error"] = true;
        $return["message"] = $e->getMessage();
    }
}

header('Content-Type: application/json');
echo json_encode($return);
