<?php
// Retrieve the JSON content and decode it into an associative array
$data = json_decode(file_get_contents('php://input'), true);

// Check if JSON data is decoded properly
if ($data === null) {
    die('JSON decode error: ' . json_last_error_msg());
}

// Database connection - replace with your database details and use PDO or mysqli
$pdo = new PDO('mysql:host=localhost;dbname=rdappnet_testrdapp', 'rdappnet_testrdapp', 'X]8wlXu)KxcG', [
    PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION
]);

$PerToken = $data['PerToken'];
$PerUserID = $data['PerUserID'];
$PerRoleID = $data['PerRoleID'];
date_default_timezone_set("Asia/Riyadh");
$TodayIs = date("Y-m-d H:i:s");

$G = $data['G'];
$S = $data['S'];
$WP = $data['WP'];
$PStageID =  $data['PStageID'];
$DegreeID = $data['DegreeID'];
$UserCheck = $pdo->prepare("SELECT Token FROM `login_tokens` WHERE `UID` = ? AND `Token` = ? LIMIT 1");
$UserCheck->bindParam(1, $PerUserID);
$UserCheck->bindParam(2, $PerToken);
$UserCheck->execute();
$UserCheckResult = $UserCheck->fetch();

if (!$UserCheckResult) {
    $return["error"] = true;
    $return["message"] = "Access denied!";
} else {
    // Prepare to handle exceptions
    try {
        $pdo->beginTransaction();

        $stmt = $pdo->prepare("SELECT COUNT(`AnswerID`) AS answerCount FROM `ins_answers` WHERE `PStageID` = ?");
        $stmt->execute([$data['PStageID']]);
        $countResult1 = $stmt->fetch(PDO::FETCH_ASSOC);
        $answerCount1 = $countResult1['answerCount'];
        if ($answerCount1 == 0) {

            // Function to handle the insertion of question types
            function insertQuestion($pdo, $type, $data, $PStageID)
            {
                if (isset($data[$type])) {
                    foreach ($data[$type] as $qodid => $info) {
                        $qid = $info['QID'];
                        $qoids = isset($info['QOID']) ? $info['QOID'] : [];
                        $QODIDs = isset($info['QODID']) ? $info['QODID'] : null;
                        $answer = isset($info['Answer']) ? $info['Answer'] : null;

                        if (is_array($qoids)) {
                            if (count($qoids) == 1 && strpos($qoids[0], ',') !== false) {
                                $qoids = explode(", ", $qoids[0]);
                            }
                        }
                        if (is_array($QODIDs)) {
                            if (count($QODIDs) == 1 && strpos($QODIDs[0], ',') !== false) {
                                $QODIDs = explode(", ", $QODIDs[0]);
                            }
                        }
                        if (is_array($info['File'])) {
                            if (count($info['File']) == 1 && strpos($info['File'][0], ',') !== false) {
                                $info['File'] = explode(", ", $info['File'][0]);
                            }
                        }
                        // Skip insertion if 'Answer' is empty for 'Text'
                        if ($type == 'Text' && empty($answer)) {
                            continue;
                        }

                        // Skip insertion if 'QOID' is empty for specified types
                        if (in_array($type, ['CheckBox', 'Radio', 'Dropdown', 'Observation', 'InsChecklist']) && empty($qoids)) {
                            continue;
                        }

                        // Special handling for Observation type when QOID and QODID are arrays
                        if ($type === 'Observation' && !empty($qoids) && is_array($qoids) && isset($QODIDs) && is_array($QODIDs)) {
                            foreach ($qoids as $index => $qoid) {
                                if (isset($QODIDs[$index])) {
                                    $qodid = $QODIDs[$index];
                                    $checkSql = "SELECT COUNT(*) FROM `ins_answers` WHERE `PStageID` = ? AND `QID` = ? AND `QOID` = ? AND `QODID` = ?";
                                    $checkStmt = $pdo->prepare($checkSql);
                                    $checkStmt->execute([$PStageID, $qid, $qoid, $qodid]);
                                    $exists = $checkStmt->fetchColumn() > 0;

                                    if (!$exists) {
                                        $sql = "INSERT INTO `ins_answers` (`PStageID`, `QID`, `QOID`, `QODID`, `File`, `Answer`) VALUES (?, ?, ?, ?, ?, ?)";
                                        $stmt = $pdo->prepare($sql);
                                        $stmt->execute([$PStageID, $qid, $qoid, $qodid, $files, $answer]);
                                    }
                                }
                            }
                        } else if ($type === 'InsChecklist' && !empty($qoids)) {
                            $qoids = isset($info['QOID']) ? (is_array($info['QOID']) ? $info['QOID'] : [$info['QOID']]) : [null];  // Normalize to array or allow null

                            foreach ($qoids as $qoid) {
                                // Check if the record already exists
                                $checkSql = "SELECT COUNT(*) FROM `ins_answers` WHERE `PStageID` = ? AND `QID` = ? AND `QOID` = ?";
                                $checkStmt = $pdo->prepare($checkSql);
                                $checkStmt->execute([$PStageID, $qid, $qoid]);
                                $exists = $checkStmt->fetchColumn() > 0;

                                if (!$exists) {
                                    $sql = "INSERT INTO `ins_answers` (`PStageID`, `QID`, `QOID`, `File`, `Answer`) VALUES (?, ?, ?, ?, ?)";
                                    $stmt = $pdo->prepare($sql);
                                    $stmt->execute([$PStageID, $qid, $qoid, $files, $answer]);
                                }
                            }
                        } else if ($type === 'CheckBox' && !empty($qoids)) {
                            foreach ($qoids as $qoid) {
                                $sql = "INSERT INTO `ins_answers` (`PStageID`, `QID`, `QOID`) VALUES (?, ?, ?)";
                                $stmt = $pdo->prepare($sql);
                                $stmt->execute([$PStageID, $qid, $qoid]);
                            }
                        } else if ($type === 'Image' || $type === 'File') {
                            if (isset($QODIDs) && is_array($QODIDs) && isset($info['File']) && is_array($qoids)) {
                                foreach ($qoids as $index => $qoid) {
                                    if (isset($QODIDs[$index])) {
                                        $qodid = $QODIDs[$index];
                                        if (isset($info['File'][$qodid]) && is_array($info['File'][$qodid])) {
                                            $fileData = [];
                                            foreach ($info['File'][$qodid] as $file) {
                                                $fileName = basename($file);
                                                $fileData[] = ["File" => $fileName, "Deleted" => "1"];
                                            }
                                            $jsonFiles = json_encode($fileData);

                                            $sql = "INSERT INTO `ins_answers` (`PStageID`, `QID`, `QOID`, `QODID`, `File`, `Answer`) VALUES (?, ?, ?, ?, ?, ?)";
                                            $stmt = $pdo->prepare($sql);
                                            if (!$stmt->execute([$PStageID, $qid, $qoid, $qodid, $jsonFiles, $answer])) {
                                                echo "Failed to insert for QID $qid with QOID $qoid and QODID $qodid\n";
                                            }
                                        }
                                    }
                                }
                            } else if (isset($QODIDs) && !is_array($QODIDs) && isset($info['File'])) {
                                $fileData = [];
                                foreach ($info['File'] as $file) {
                                    $fileName = basename($file);
                                    $fileData[] = ["File" => $fileName, "Deleted" => "1"];
                                }
                                $jsonFiles = json_encode($fileData);

                                // Insert directly under QID, handling cases without QOID or QODID
                                $checkSql = "SELECT COUNT(*) FROM `ins_answers` WHERE `PStageID` = ? AND `QID` = ? AND `QOID` = ? AND `QODID` = ?";
                                $checkStmt = $pdo->prepare($checkSql);
                                $checkStmt->execute([$PStageID, $qid, $qoids, $QODIDs]);
                                $exists = $checkStmt->fetchColumn() > 0;

                                if (!$exists) {
                                    $sql = "INSERT INTO `ins_answers` (`PStageID`, `QID`, `QOID`, `QODID`, `File`, `Answer`) VALUES (?, ?, ?, ?, ?, ?)";
                                    $stmt = $pdo->prepare($sql);
                                    $stmt->execute([$PStageID, $qid, $qoids, $QODIDs, $jsonFiles, $answer]);
                                } else {
                                    $updateStmt = $pdo->prepare("UPDATE `ins_answers` SET `File` = ? WHERE `PStageID` = ? AND `QID` = ? AND `QOID` = ? AND `QODID` = ?");
                                    $updateStmt->execute([$jsonFiles, $PStageID, $qid, $qoids, $QODIDs]);
                                }
                            } else if (isset($info['File']) && empty($QODIDs) && empty($qoids)) {
                                // Handle direct file list under QID without QODID
                                $fileData = [];
                                foreach ($info['File'] as $file) {
                                    $fileName = basename($file);
                                    $fileData[] = ["File" => $fileName, "Deleted" => "1"];
                                }
                                $jsonFiles = json_encode($fileData);

                                // Insert directly under QID, handling cases without QOID or QODID
                                $sql = "INSERT INTO `ins_answers` (`PStageID`, `QID`, `File`, `Answer`) VALUES (?, ?, ?, ?)";
                                $stmt = $pdo->prepare($sql);
                                $stmt->execute([$PStageID, $qid, $jsonFiles, $answer]);
                            } else if (isset($info['File']) && empty($QODIDs)) {
                                // Handle direct file list under QID without QODID
                                $fileData = [];
                                foreach ($info['File'] as $file) {
                                    $fileName = basename($file);
                                    $fileData[] = ["File" => $fileName, "Deleted" => "1"];
                                }
                                $jsonFiles = json_encode($fileData);

                                // Insert directly under QID, handling cases without QOID or QODID
                                $qoid = is_array($qoids) ? implode(',', $qoids) : $qoids;
                                $sql = "INSERT INTO `ins_answers` (`PStageID`, `QID`, `QOID`, `File`, `Answer`) VALUES (?, ?, ?, ?, ?)";
                                $stmt = $pdo->prepare($sql);
                                $stmt->execute([$PStageID, $qid, $qoid, $jsonFiles, $answer]);
                            }
                        } else {
                            // Standard insertion for other cases
                            $qoid = is_array($qoids) ? implode(',', $qoids) : $qoids;
                            $files = isset($info['File']) ? json_encode($info['File']) : null;
                            // $QODIDs = isset($QODIDs) ? json_encode($QODIDs) : null;
                            $sql = "INSERT INTO `ins_answers` (`PStageID`, `QID`, `QOID`, `QODID`, `File`, `Answer`) VALUES (?, ?, ?, ?, ?, ?)";
                            $stmt = $pdo->prepare($sql);
                            $stmt->execute([$PStageID, $qid, $qoid, $QODIDs, $files, $answer]);
                        }
                    }
                }
            }

            // Loop through each question type and insert data
            $types = ['UserSelect', 'Image', 'File', 'Text', 'CheckBox', 'Radio', 'Dropdown', 'Observation', 'InsChecklist'];
            foreach ($types as $type) {
                insertQuestion($pdo, $type, $data, $data['PStageID']);
            }

            //-----------------------------------------------
            $res77 = $pdo->query("SELECT `ProjectID`, `StageID`  FROM `project_stages` WHERE `PStageID` = '$PStageID'");
            $numrows33 = $res77->rowCount();
            if ($numrows33 > 0) {
                $row77 = $res77->fetch();
                $ProjectID = $row77['ProjectID'];
                $StageID = $row77['StageID'];

                if (!empty($DegreeID) && $DegreeID == 11) {

                    $stmt = $pdo->prepare("SELECT `PStageID` FROM `AV_quotation` WHERE `ProjectID` = ? AND `PStageID` = ? AND `Deleted` = '0' AND `Paid` = '0'");
                    $stmt->execute([$ProjectID, $PStageID]);
                    $AVRow = $stmt->rowCount();
                    if ($AVRow == 0) {

                        error_log('Inserting into AV_quotation');

                        if (isset($data[$type])) {
                            foreach ($data[$type] as $qodid => $info) {
                                $qoids = isset($info['QOID']) ? $info['QOID'] : [];

                                if ($type === 'InsChecklist' && !empty($qoids)) {
                                    $qoids = isset($info['QOID']) ? (is_array($info['QOID']) ? $info['QOID'] : [$info['QOID']]) : [null];  // Normalize to array or allow null

                                    foreach ($qoids as $qoid) {

                                        $res5 = $pdo->query("SELECT ins_questions.`TICode` FROM `ins_questions`,ins_questions_options WHERE `ins_questions`.`QID` = ins_questions_options.QID and ins_questions_options.QOID = '$qoid' AND ins_questions.`Deleted` = '0'");
                                        $row5 = $res5->fetch();
                                        $TICode = $row5['TICode'];

                                        $res5 = $pdo->query("SELECT `QData`FROM `ins_questions_options_data` WHERE `OID` = '$qoid' AND `DegreeID` = '11' AND `Deleted` = '0'");
                                        $row5 = $res5->fetch();
                                        $Description = $row5['QData'];

                                        if (!empty($Description) and !empty($TICode)) {

                                            $stmt = $pdo->prepare("INSERT INTO `Ticket`(`StageID`, `PStageID`, `ProjectID`, `UserID`, `Code`, `Description`,`CreatedAt`) 
                                            VALUES (?, ?, ?, ?, ?, ?, ?)");
                                           $result = $stmt->execute([$StageID, $PStageID, $ProjectID, $PerUserID,  $TICode, $Description, $TodayIs]);
                                           
                                            if ($result) {
                                                $last_tid = $pdo->lastInsertId();

                                                $stmt = $pdo->prepare("INSERT INTO `TicketHistory` (`TicketID`, `UpdaterID`, `CommentEN`, `CommentAR` ,`CorrectiveEN` ,`CorrectiveAR`, `DegreeID`, `CreatedAt`)
                    VALUES (?, ?, ?, ?, ?, ?, ?, ?)");
                                                $stmt->execute([$last_tid, $PerUserID, $Description, $CommentAR, $CorrectiveEN, $CorrectiveAR, 11, $TodayIs]);
    
                                                $res78 = $pdo->query("SELECT `PStageID` FROM `AV_quotation` WHERE `ProjectID` = '$ProjectID' AND `PStageID` = '$PStageID' AND `Deleted` = '0' AND `Paid` = '0'");
                                                $numrows38 = $res78->rowCount();
                                                if ($numrows38 == 0) {

                                                    $Token = bin2hex(random_bytes(5));
                                                    $PayLink = "https://checkout.cpvarabia.com/#/?Token=" . $Token;
                                                    $resavs = $pdo->query("SELECT `PStageID` FROM `AV_quotation` WHERE `ProjectID` = '$ProjectID' AND `Deleted` = '0' AND `Paid` = '1'");
                                                    $resavnm = $resavs->rowCount();

                                                    $resx11 = $pdo->query("SELECT `VisitsNo` FROM `projects` WHERE `ProjectID` = '$ProjectID' AND `Deleted` = '0'");
                                                    $row5 = $resx11->fetch();

                                                    $VisitsNo =  $row5['VisitsNo'] -  $resavnm;

                                                    if ($VisitsNo > 6) {

                                                        $stmt = $pdo->prepare("INSERT INTO `AV_quotation` (`ProjectID`, `TicketID`, `UserID`, `PStageID`,  `AVCost`, `VAT`, `AVTotal`, `Paid`, `PaymentLink`) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)");
                                                        $result = $stmt->execute([$ProjectID, $last_tid, $PerUserID, $PStageID, 0, 0, 0, '2', 'Free']);
                                                    } else {
                                                        $stmt = $pdo->prepare("INSERT INTO `checkout`(`Token`, `ProjectID`, `UserID`, `Type`, `Status`,  `Amount`, `Delated`) VALUES (?, ?, ?, ?, ?, ?, ?)");
                                                        $res12 = $stmt->execute([$Token, $ProjectID, $PerUserID, 'AV', 0, 690, 0]);
                                                        if ($res12) {
                                                            $stmt = $pdo->prepare("INSERT INTO `AV_quotation` (`ProjectID`, `TicketID`, `UserID`, `PStageID`,  `AVCost`, `VAT`, `AVTotal`, `PaymentLink`) VALUES (?, ?, ?, ?, ?, ?, ?, ?)");
                                                            $result = $stmt->execute([$ProjectID, $last_tid, $PerUserID, $PStageID, 600, 90, 690, $PayLink]);
                                                            if (!$result) {
                                                                $errorInfo = $stmt->errorInfo();
                                                                error_log('SQL Error: ' . print_r($errorInfo, true));
                                                            } else {
                                                                error_log('Successfully inserted into AV_quotation');
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                } else if (!empty($DegreeID) && $DegreeID == 7) {

                    if (isset($data[$type])) {
                        foreach ($data[$type] as $qodid => $info) {
                            $qoids = isset($info['QOID']) ? $info['QOID'] : [];

                            if ($type === 'InsChecklist' && !empty($qoids)) {
                                $qoids = isset($info['QOID']) ? (is_array($info['QOID']) ? $info['QOID'] : [$info['QOID']]) : [null];  // Normalize to array or allow null

                                foreach ($qoids as $qoid) {

                                    $res5 = $pdo->query("SELECT ins_questions.`TICode` FROM `ins_questions`,ins_questions_options WHERE `ins_questions`.`QID` = ins_questions_options.QID and ins_questions_options.QOID = '$qoid' AND ins_questions.`Deleted` = '0'");
                                    $row5 = $res5->fetch();
                                    $TICode = $row5['TICode'];

                                    $res5 = $pdo->query("SELECT CommentEN, CommentAR, CorrectiveEN, CorrectiveAR FROM `ins_questions_options_data` WHERE `OID` = '$qoid' AND `DegreeID` = '7' AND `Deleted` = '0'");
                                    $row5 = $res5->fetch();
                                    $Description = $row5['CommentEN'];
                                    $CommentAR = $row5['CommentAR'];
                                    $CorrectiveEN = $row5['CorrectiveEN'];
                                    $CorrectiveAR = $row5['CorrectiveAR'];
                                    error_log($Description . '-' . $TICode);

                                    if (!empty($Description) and !empty($TICode)) {

                                        $stmt = $pdo->prepare("INSERT INTO `Ticket`(`StageID`, `PStageID`, `ProjectID`, `UserID`, `Code`, `Description`,`CreatedAt`) 
                                        VALUES (?, ?, ?, ?, ?, ?, ?)");
                                        $result = $stmt->execute([$StageID, $PStageID, $ProjectID, $PerUserID,  $TICode, $Description, $TodayIs]);
                                
                                        if ($result) {
                                            $Token = bin2hex(random_bytes(10));
                                            $last_tid = $pdo->lastInsertId();

                                            $stmt = $pdo->prepare("INSERT INTO `TicketHistory` (`TicketID`, `UpdaterID`, `CommentEN`, `CommentAR` ,`CorrectiveEN` ,`CorrectiveAR`, `DegreeID`, `CreatedAt`)
                VALUES (?, ?, ?, ?, ?, ?, ?, ?)");
                                            $stmt->execute([$last_tid, $PerUserID, $Description, $CommentAR, $CorrectiveEN, $CorrectiveAR, 7, $TodayIs]);

                                            $stmt = $pdo->prepare("INSERT INTO `rd5_reports` (`Token`, `UserID`, `TicketID`,`Status`,`Type`,`CreatedAt`) 
                VALUES (?, ?, ?, 'Active', 'WI', ?)");
                                            $stmt->execute([$Token, $PerUserID, $last_tid, $TodayIs]);
                                        }
                                    }
                                }
                            }
                        }
                    }
                } else if (!empty($DegreeID) && $DegreeID == 8) {
                    $stmt = $pdo->prepare("SELECT `Cost` FROM `project_costs` WHERE `ProjectID` = ?");
                    $stmt->execute([$ProjectID]);
                    $row7 = $stmt->fetch();
                    $B4 = $row7['Cost'];

                    $G1 = ($G / 100) * 0.15;    //(G = 30 or 50 etc not 0.3)
                    $S1 = ($S / 100) * 0.1;    //(S = 30 or 50 etc not 0.3)
                    $WP1 = ($WP / 100) * 0.2;    //(WP = 30 or 50 etc not 0.3)

                    $B41 = $B4;

                    if ($G1 > 0) {
                        $Gcost = Max($B41 * $G1 / 100, 1200);
                    } else {
                        $Gcost = $B41 * $G1;
                    }

                    if ($S1 > 0) {
                        $Scost = Max($B41 * $S1 / 100, 800);
                    } else {
                        $Scost = $B41 * $S1;
                    }

                    if ($WP1 > 0) {
                        $WPcost = Max($B41 * $WP1 / 100, 1600);
                    } else {
                        $WPcost = $B41 * $WP1;
                    }


                    $B3 = $G1 + $S1 + $WP1;            //(Total cost percentage)

                    $B5 = $Gcost + $Scost + $WPcost;        //(Include VAT)
                    $B6 = round($B5, 0);            //(with round)
                    $VAT = $B6 * 0.15;        //(VAT Only)
                    $B7 = $B6 + $VAT;

                    if (isset($data[$type])) {
                        foreach ($data[$type] as $qodid => $info) {
                            $qoids = isset($info['QOID']) ? $info['QOID'] : [];

                            if ($type === 'InsChecklist' && !empty($qoids)) {
                                $qoids = isset($info['QOID']) ? (is_array($info['QOID']) ? $info['QOID'] : [$info['QOID']]) : [null];  // Normalize to array or allow null

                                foreach ($qoids as $qoid) {

                                    $res5 = $pdo->query("SELECT ins_questions.`TICode` FROM `ins_questions`,ins_questions_options WHERE `ins_questions`.`QID` = ins_questions_options.QID and ins_questions_options.QOID = '$qoid' AND ins_questions.`Deleted` = '0'");
                                    $row5 = $res5->fetch();
                                    $TICode = $row5['TICode'];

                                    $res5 = $pdo->query("SELECT CommentEN, CommentAR, CorrectiveEN, CorrectiveAR  FROM `ins_questions_options_data` WHERE `OID` = '$qoid' AND `DegreeID` = '8' AND `Deleted` = '0'");
                                    $row5 = $res5->fetch();

                                    $Description = $row5['CommentEN'];
                                    $CommentAR = $row5['CommentAR'];
                                    $CorrectiveEN = $row5['CorrectiveEN'];
                                    $CorrectiveAR = $row5['CorrectiveAR'];

                                    if (!empty($Description) and !empty($TICode)) {
                                        //$Description = 'The project has a missing stage';

                                        $stmt = $pdo->prepare("SELECT rd5_reports.`TicketID` FROM `rd5_reports`, `Ticket` WHERE `rd5_reports`.`TicketID` = `Ticket`.`TicketID` AND `Ticket`.`ProjectID` = ? AND `rd5_reports`.`UserID` = ? AND `rd5_reports`.`Status` = 'Active' AND `rd5_reports`.`Type` = 'MS'");
                                        $stmt->execute([$ProjectID, $PerUserID]);
                                        $numrows3 = $stmt->rowCount();
                                        if ($numrows3 == 0) {
                                            $Token = bin2hex(random_bytes(5));

                                            $stmt = $pdo->prepare("INSERT INTO `checkout` (`Token`, `ProjectID`, `UserID`, `Type`, `Status`,  `Amount`, `CreatedAt`, `Delated`)
                VALUES (?, ?, ?, ?, '0', ?, ?, '0')");
                                            $stmt->execute([$Token, $ProjectID, $PerUserID, 'RD7', $B7, $TodayIs]);

                                            $PayLink = "https://checkout.cpvarabia.com/#/?Token=" . $Token;

                                            $stmt = $pdo->prepare("INSERT INTO `rd7_quotation` (`Token`, `ProjectID`, `UserID`, `RD7Status`, `G`, `S`, `WP`, `NoUnit`, `RD7Percent`, `RD7Cost`, `PCost`, `VAT`, `RD7Total`, `PaymentLink`, `CreatedAt`)
                VALUES (?, ?, ?, '1', ?, ?, ?, '1', ?, ?, ?, ?, ?, ?, ?)");
                                            $stmt->execute([$Token, $ProjectID, $PerUserID, $G, $S, $WP, $B3, $B6, $B4, $VAT, $B7, $PayLink, $TodayIs]);
                                            $last_rd7qid = $pdo->lastInsertId();

                                            $stmt = $pdo->prepare("INSERT INTO `Ticket`(`StageID`, `PStageID`, `ProjectID`, `UserID`, `Code`, `Description`,`CreatedAt`) 
                                            VALUES (?, ?, ?, ?, ?, ?, ?)");
                                            $stmt->execute([$StageID, $PStageID, $ProjectID, $PerUserID,  $TICode, $Description, $TodayIs]);
                                            $last_tid = $pdo->lastInsertId();


                                            $stmt = $pdo->prepare("INSERT INTO `TicketHistory` (`TicketID`, `UpdaterID`, `CommentEN`, `CommentAR` ,`CorrectiveEN` ,`CorrectiveAR`, `DegreeID`, `CreatedAt`)
                VALUES (?, ?, ?, ?, ?, ?, ?, ?)");
                                            $stmt->execute([$last_tid, $PerUserID, $Description, $CommentAR, $CorrectiveEN, $CorrectiveAR, 8, $TodayIs]);


                                            $stmt = $pdo->prepare("INSERT INTO `rd5_reports` (`Token`, `UserID`, `TicketID`,`Status`,`G`,`S`,`WP`,`Type`,`CreatedAt`)
                VALUES (?, ?, ?, 'Active', ?, ?, ?, 'MS', ?)");
                                            $stmt->execute([$Token, $PerUserID, $last_tid, $G, $S, $WP, $TodayIs]);
                                            $last_rd5id = $pdo->lastInsertId();

                                            $stmt = $pdo->prepare("INSERT INTO `rd7_reports` (`ProjectID`, `QuotationID`, `RD5ID`, `InsUserID`, `Status`, `CreatedBy`, `CreatedAt`) VALUES (?, ?, ?, ?, '3', ?, ?)");
                                            $stmt->execute([$ProjectID, $last_rd7qid, $last_rd5id, $PerUserID, $PerUserID, $TodayIs]);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }


                if ($StageID == 7) {

                    $updateStmt = $pdo->prepare("UPDATE `RD6_Addendum` SET `Status` = '2'  WHERE `ProjectID` = ? AND `Status` = '1' AND `Deleted` = '0'");
                    $updateStmt->execute([$data['$ProjectID']]);

                    $stmt = $pdo->prepare("SELECT `InspectorID` FROM `project_stages` WHERE `StageID`= '10' AND `Deleted` = '0' AND `ProjectID` = ? ");
                    $stmt->execute([$ProjectID]);
                    $row7 = $stmt->fetch();
                    $DesUserID = $row7['InspectorID'];

                    $stmt = $pdo->prepare("INSERT INTO `rd6_reports` (`ProjectID`, `FVID`, `InsUserID`, `DesUserID`, `CreatedAt`, `Deleted`) VALUES (?, ?, ?, ?, ?, '0')");
                    $stmt->execute([$ProjectID, $PStageID, $PerUserID, $DesUserID, $TodayIs]);
                    $stmt = $pdo->prepare("INSERT INTO `Site_Visits` (`InspectorID`, `ProjectID`, `Type`, `Date`, `Deleted`) VALUES (?, ?, ?, ?, '0')");
                    $stmt->execute([$PerUserID, $ProjectID, '7', $TodayIs]);
                }
            }
            //-----------------------------------------------
            $stmt = $pdo->prepare("SELECT COUNT(`AnswerID`) AS answerCount FROM `ins_answers` WHERE `PStageID` = ?");
            $stmt->execute([$data['PStageID']]);
            $countResult1 = $stmt->fetch(PDO::FETCH_ASSOC);
            $answerCount1 = $countResult1['answerCount'];
            error_log($answerCount1);

            // Commit the transaction
            $pdo->commit();
            $stmt = $pdo->prepare("SELECT COUNT(`AnswerID`) AS answerCount FROM `ins_answers` WHERE `PStageID` = ?");
            $stmt->execute([$data['PStageID']]);
            $countResult = $stmt->fetch(PDO::FETCH_ASSOC);
            $answerCount = $countResult['answerCount'];

            // Compare the retrieved count with the expected count from `$data`
            if ($answerCount == $data['Count']) {
                // If counts match, update `project_stages`
                $updateStmt = $pdo->prepare("UPDATE `project_stages` SET `Synced` = '1', `Deleted` = '0' WHERE `PStageID` = ? AND `Deleted` = '1'");
                $updateStmt->execute([$data['PStageID']]);

                $res78 = $pdo->query("SELECT `DID` FROM `Declaration` WHERE `ProjectID` ='$ProjectID' and `InspectorID`='$PerUserID'");
                $numrows38 = $res78->rowCount();
                if ($numrows38 == 0) {
                    $stmt = $pdo->prepare("INSERT INTO `Declaration` (`ProjectID`, `InspectorID`,`CreatedAt`) VALUES (?, ?, ?");
                    $stmt->execute([$ProjectID, $PerUserID, $TodayIs]);
                }
                $return["error"] = false;
                $return["message"] = "Success!";
                error_log('Data: ' . print_r($data, true));
            } else {
                // If counts do not match, return an error message
                $return["error"] = true;
                $return["message"] = "Receive only: " . $answerCount;
                error_log('Data: ' . print_r($data, true));
            }
        } else {
            $return["error"] = false;
            $return["message"] = "Success!";
            error_log('Data: ' . print_r($data, true));
        }
    } catch (Exception $e) {
        // An error occurred; rollback the transaction
        $pdo->rollback();
        $return["error"] = true;
        $return["message"] =  $e->getMessage();
    }
}

header('Content-Type: application/json');
echo json_encode($return);
